/*
 * Transcoder.Interfaces TranscoderInterfaces.h
 * Copyright (C) 2007-2008 doubleTwist Corporation
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

using namespace System;
using namespace System::IO;
using namespace System::Runtime::Serialization;
using namespace System::Reflection;
using namespace System::Collections::Generic;

namespace Dune {
namespace Components {
namespace Transcode {

	public delegate bool ProgressDelegate(float);

	public interface class IProgress
	{
		public: bool Update(float percentComplete);
		public: void SetCallback(IntPtr progressCB);
	};

	public interface class IDTAppInfo
	{
		public: int GetProcessID();
	};

	public interface class ITranscoder
	{
		public: void Transcode(array<String^>^ transcodeArgs, IntPtr progress);
		public: void Transcode(array<Stream^>^ inputStreams, array<String^>^ transcodeArgs, IntPtr progress);
		public: Dune::Components::Common::IMetadata^ GetMetadata(Stream^ inputStream, String^ fileExtension);
		public: void SetLogFile(String^ filePath);
	};

}
}
}
